Index: cpp/tests/full_props-fS.goal
===================================================================
--- cpp/tests/full_props-fS.goal	(revision 1033)
+++ cpp/tests/full_props-fS.goal	(revision 1067)
@@ -1,16 +1,16 @@
 //0s
 m:se=1.0, Vstyle=
-p:x=0.0, y=0.0, z=0.0, sh=2, s=1.0, sx=0.806, sy=0.806, sz=2.295, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.0, ry=0.0, rz=0.0, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=1.6610658177212956, y=0.0, z=0.0, sh=2, s=1.0, sx=0.806, sy=1.0, sz=0.806, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.0, ry=0.0, rz=0.0, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=2.669522581015868, y=-0.12927953115999094, z=1.770803754024758, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=2.5149067817465802, y=-0.12852148117052686, z=1.7757109168238943, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.275, as=0.25, rx=-1.277, ry=-1.087, rz=-0.9208, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=3.491120795397971, y=0.0627093264475479, z=3.542562176271334, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.4085, ry=1.0807, rz=0.5977, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=4.82498021179015, y=-1.4556859677056804, z=3.7057221690326423, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=-0.9279, ry=-0.2806, rz=-0.7292, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=2.044122892122303, y=0.0, z=0.0, sh=3, s=1.0, sx=1.0144, sy=0.903, sz=0.903, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=0.0, ry=0.271, rz=0.0, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=2.1225041839451873, y=0.3558613626799459, z=1.8896569415253044, sh=3, s=1.0, sx=0.8736, sy=0.8736, sz=0.8736, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.3229, ry=-0.3828, rz=1.5117, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=3.2159989925040344, y=-0.15022914055334208, z=2.057760603467444, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=1.0846131653683386, y=-0.09317957887309433, z=-3.5838606901740344, sh=2, s=1.0, sx=1.273, sy=0.133, sz=1.509, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=-0.9744, ry=-1.5695, rz=1.1659, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=0.1364642552368182, y=0.619565647570761, z=3.289951226640109, sh=3, s=1.0, sx=0.8736, sy=0.8736, sz=0.8736, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.3229, ry=-0.3828, rz=1.5117, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
-p:x=1.6422082610960242, y=-0.21052356609516198, z=2.883642273506047, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vs=0.2, vr=1.0, vg=1.0, vb=1.0
+p:x=0.0, y=0.0, z=0.0, sh=2, s=1.0, sx=0.806, sy=0.806, sz=2.295, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.0, ry=0.0, rz=0.0, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=1.6610658177212956, y=0.0, z=0.0, sh=2, s=1.0, sx=0.806, sy=1.0, sz=0.806, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.0, ry=0.0, rz=0.0, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=2.669522581015868, y=-0.12927953115999094, z=1.770803754024758, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=2.5149067817465802, y=-0.12852148117052686, z=1.7757109168238943, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.275, as=0.25, rx=-1.277, ry=-1.087, rz=-0.9208, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=3.491120795397971, y=0.0627093264475479, z=3.542562176271334, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.4085, ry=1.0807, rz=0.5977, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=4.82498021179015, y=-1.4556859677056804, z=3.7057221690326423, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=-0.9279, ry=-0.2806, rz=-0.7292, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=2.044122892122303, y=0.0, z=0.0, sh=3, s=1.0, sx=1.0144, sy=0.903, sz=0.903, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=0.0, ry=0.271, rz=0.0, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=2.1225041839451873, y=0.3558613626799459, z=1.8896569415253044, sh=3, s=1.0, sx=0.8736, sy=0.8736, sz=0.8736, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.3229, ry=-0.3828, rz=1.5117, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=3.2159989925040344, y=-0.15022914055334208, z=2.057760603467444, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=1.0846131653683386, y=-0.09317957887309433, z=-3.5838606901740344, sh=2, s=1.0, sx=1.273, sy=0.133, sz=1.509, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=-0.9744, ry=-1.5695, rz=1.1659, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=0.1364642552368182, y=0.619565647570761, z=3.289951226640109, sh=3, s=1.0, sx=0.8736, sy=0.8736, sz=0.8736, h=0.0, dn=1.0, fr=0.4, ing=0.25, as=0.25, rx=0.3229, ry=-0.3828, rz=1.5117, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
+p:x=1.6422082610960242, y=-0.21052356609516198, z=2.883642273506047, sh=1, s=1.0, sx=1.0, sy=1.0, sz=1.0, h=0.0, dn=1.0, fr=0.4, ing=0.22727272727272727, as=0.25, rx=1.3416, ry=-1.3967, rz=1.1368, i=, Vstyle=part, vr=1.0, vg=1.0, vb=1.0
 j:p1=0, p2=1, sh=1, hx=0.0, hy=0.0, hz=0.0, hrx=0.0, hry=0.0, hrz=0.0, hxn=-1.5708, hxp=1.5708, hyn=-1.5708, hyp=1.5708, stif=1.0, rotstif=1.0, stam=0.25, i=, Vstyle=joint, vr=1.0, vg=1.0, vb=1.0
 j:p1=1, p2=2, sh=1, hx=0.0, hy=0.0, hz=0.0, hrx=0.0, hry=0.0, hrz=0.0, hxn=-1.5708, hxp=1.5708, hyn=-1.5708, hyp=1.5708, stif=1.0, rotstif=1.0, stam=0.25, i=, Vstyle=joint, vr=1.0, vg=1.0, vb=1.0