Index: /framspy/eval-allcriteria.sim
===================================================================
--- /framspy/eval-allcriteria.sim	(revision 1092)
+++ /framspy/eval-allcriteria.sim	(revision 1093)
@@ -1,10 +1,10 @@
-# Created Thu Jun 10 11:08:43 2020
 # Sample settings for evaluating many criteria of performance of a Framsticks creature.
 # See the "evalcount" parameter if you want to speed the evaluation up or have a more stable result.
 # Other important parameters are "Energy0" and "perfperiod".
+# Put this file in the "data" subdirectory within the Framsticks distribution.
 sim_params:
 stop_on:2
-last_genotype_num:1
-last_creature_num:20
+last_genotype_num:0
+last_creature_num:0
 expdef:standard-eval
 usercode:
@@ -19,5 +19,5 @@
 vm_time_limit:0.0
 vm_time_warning:0.0
-version_int:7
+version_int:11
 initialgen:X
 capacity:0
@@ -69,32 +69,8 @@
 nnspeed:1.0
 rndcollisions:1
-odeshape:0
-odestep:0.05
-odemusclemin:0.0
-odemusclemax:10.0
-odemusclespeed:1.0
-odeairdrag:0.01
-oderotdrag:0.01
-odewaterdrag:0.5
-odewaterbuoy:1.0
-odeseed:0
-odesepsticks:0
-odeworlderp:0.2
-odeworldcfm:1e-5
-odecolmumin:0.1
-odecolmumax:5.0
-odecolbounce:0.1
-odecolbouncevel:0.01
-odecolsoftcfm:0.0
-odecolsofterp:0.0
-odecol2mumin:0.1
-odecol2mumax:1.0
-odecol2bounce:0.1
-odecol2bouncevel:0.01
-odecol2softcfm:0.0
-odecol2softerp:0.0
 gen_hilite:1
 gen_extmutinfo:0
 genoper_f0:0
+genoper_f0s:0
 genoper_f1:0
 genoper_f2:0
@@ -108,12 +84,17 @@
 genoper_fH:0
 genoper_fL:0
+genoper_fS:0
 neuadd_N:1
 neuadd_Nu:0
 neuadd_G:1
+neuadd_Gpart:1
 neuadd_T:1
+neuadd_Tcontact:0
+neuadd_Tproximity:0
 neuadd_S:1
 neuadd_Constant:1
 neuadd_Bend_muscle:1
 neuadd_Rotation_muscle:1
+neuadd_M:1
 neuadd_D:0
 neuadd_Fuzzy:0
@@ -145,9 +126,8 @@
 f0_p_swp:10.0
 f0_p_pos:10.0
-f0_p_mas:10.0
+f0_p_den:0.0
 f0_p_frc:10.0
 f0_p_ing:10.0
 f0_p_asm:10.0
-f0_p_vsiz:0.0
 f0_j_new:5.0
 f0_j_del:5.0
@@ -164,4 +144,31 @@
 f0_c_del:5.0
 f0_c_wei:10.0
+f0s_nodel_tag:1
+f0s_nomod_tag:1
+f0s_circle_section:1
+f0s_use_elli:1
+f0s_use_cub:1
+f0s_use_cyl:1
+f0s_p_new:5.0
+f0s_p_del:5.0
+f0s_p_swp:10.0
+f0s_p_pos:10.0
+f0s_p_rot:10.0
+f0s_p_scale:10.0
+f0s_p_frc:10.0
+f0s_p_ing:10.0
+f0s_p_asm:0.0
+f0s_j_new:5.0
+f0s_j_del:5.0
+f0s_j_stm:0.0
+f0s_j_vred:0.0
+f0s_j_vgrn:0.0
+f0s_j_vblu:0.0
+f0s_n_new:5.0
+f0s_n_del:5.0
+f0s_n_prp:10.0
+f0s_c_new:5.0
+f0s_c_del:5.0
+f0s_c_wei:10.0
 f1_xo_propor:1
 f1_smX:0.05
@@ -169,5 +176,5 @@
 f1_smComma:0.02
 f1_smModif:0.1
-f1_mut_exmod:EeWwAaSsDdGgBbHh
+f1_mut_exmod:EeWwAaSsDdGgBb
 f1_nmNeu:0.05
 f1_nmConn:0.1
@@ -199,5 +206,5 @@
 f4_mut_del:20.0
 f4_mut_mod:30.0
-f4_mut_exmod:EeWwAaSsDdGgBbHh
+f4_mut_exmod:EeWwAaSsDdGgBb
 f8_mut_chg_begin_arg:7.0
 f8_mut_chg_arg:7.0
@@ -257,4 +264,23 @@
 fL_mut_changeiter_step:1.0
 fL_mut_deletion:0.2
+fS_mut_add_part:10.0
+fS_mut_rem_part:10.0
+fS_mut_mod_part:10.0
+fS_mut_change_joint:10.0
+fS_mut_add_param:10.0
+fS_mut_rem_param:10.0
+fS_mut_mod_param:10.0
+fS_mut_mod_mod:10.0
+fS_mut_add_neuro:10.0
+fS_mut_rem_neuro:10.0
+fS_mut_mod_neuro_conn:10.0
+fS_mut_add_neuro_conn:10.0
+fS_mut_rem_neuro_conn:10.0
+fS_mut_mod_neuro_params:10.0
+fS_circle_section:1
+fS_use_elli:1
+fS_use_cub:1
+fS_use_cyl:1
+fS_mut_add_part_strong:1
 genkonw0:1
 genkonw1:1
@@ -268,4 +294,5 @@
 genkonw9:1
 genkonw10:1
+genkonw11:1
 randinit:0.01
 nnoise:0.0
@@ -276,9 +303,13 @@
 ncl_Nu:1
 ncl_G:1
+ncl_Gpart:1
 ncl_T:1
+ncl_Tcontact:1
+ncl_Tproximity:1
 ncl_S:1
 ncl_Constant:1
 ncl_Bend_muscle:1
 ncl_Rotation_muscle:1
+ncl_M:1
 ncl_D:1
 ncl_Fuzzy:1
@@ -304,5 +335,13 @@
 ncl_S1:1
 ncl_Thr:1
-simil_method:0
+# "type" is deprecated since rc19, to be removed
+type:1
+simil_type:1
+simil_greedy_parts:0.0
+simil_greedy_partdeg:1.0
+simil_greedy_neuro:0.1
+simil_greedy_partgeom:1.0
+simil_greedy_fixedZaxis:0
+simil_greedy_weightedMDS:1
 simil_parts:0.0
 simil_partdeg:1.0
@@ -311,4 +350,7 @@
 simil_fixedZaxis:0
 simil_weightedMDS:0
+simil_density:10.0
+simil_bin_num:128
+simil_samples_num:1048576
 symPosSteps:10
 symAlphaSteps:20