Index: cpp/tests/genoconv_test-simplemultiply.goal
===================================================================
--- cpp/tests/genoconv_test-simplemultiply.goal	(revision 1009)
+++ cpp/tests/genoconv_test-simplemultiply.goal	(revision 1143)
@@ -7,17 +7,17 @@
 *** Converted:
 Genotype:
-p:vr=0.5, 0.5, 0.5
-p:1.0, vr=0.5, 0.5, 0.5
-p:2.0, vr=0.5, 0.5, 0.5
-p:3.0, vr=0.5, 0.5, 0.5
-p:4.0, vr=0.5, 0.5, 0.5
-p:5.0, vr=0.5, 0.5, 0.5
-p:6.0, vr=0.5, 0.5, 0.5
-j:0, 1, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
-j:1, 2, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
-j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
-j:3, 4, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
-j:4, 5, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
-j:5, 6, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5
+p:
+p:1.0
+p:2.0
+p:3.0
+p:4.0
+p:5.0
+p:6.0
+j:0, 1, dx=1.0, 0.0, 0.0
+j:1, 2, dx=1.0, 0.0, 0.0
+j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0
+j:3, 4, dx=1.0, 0.0, 0.0
+j:4, 5, dx=1.0, 0.0, 0.0
+j:5, 6, dx=1.0, 0.0, 0.0
 
 Format: 0
@@ -25,51 +25,48 @@
 Comment: 
 Conversion map:
-{ [1] -> [0-66,163-248]
+{ [1] -> [0-14,39-88]
   [2] -> []
-  [3] -> [43-66]
+  [3] -> [9-14]
   [4] -> []
-  [5] -> [67-138,249-389]
+  [5] -> [15-32,89-175]
   [6] -> []
-  [7] -> [115-138]
-  [8] -> [139-162,390-432]
+  [7] -> [27-32]
+  [8] -> [33-38,176-200]
   [9] -> []
-  [10] -> [115-138]
+  [10] -> [27-32]
 }
-                  p:vr=0.5, 0.5, 0.5 p:1.0, vr=0.5, 0.5, 0.5 p:2.0, vr=0.5, 0.5, 0.5 p:3.0, vr=0.5, 0.5, 0.5 p:4.0, vr=0.5, 0.5, 0.5 p:5.0, vr=0.5, 0.5, 0.5 p:6.0, vr=0.5, 0.5, 0.5 j:0, 1, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:1, 2, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:3, 4, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:4, 5, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:5, 6, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 
-              2 : .................................................................................................................................................................................................................................................................................................................................................................................................................................................
-              X : p:vr=0.5, 0.5, 0.5 p:1.0, vr=0.5, 0.5, 0.5 p:2.0, vr=0.5, 0.5, 0.5 ................................................................................................j:0, 1, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:1, 2, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 ........................................................................................................................................................................................
-              2 : .................................................................................................................................................................................................................................................................................................................................................................................................................................................
-              r : ...........................................p:2.0, vr=0.5, 0.5, 0.5 ..............................................................................................................................................................................................................................................................................................................................................................................
-              3 : .................................................................................................................................................................................................................................................................................................................................................................................................................................................
-              X : ...................................................................p:3.0, vr=0.5, 0.5, 0.5 p:4.0, vr=0.5, 0.5, 0.5 p:5.0, vr=0.5, 0.5, 0.5 ..............................................................................................................j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:3, 4, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j:4, 5, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 ...........................................
-              2 : .................................................................................................................................................................................................................................................................................................................................................................................................................................................
-              ( : ...................................................................................................................p:5.0, vr=0.5, 0.5, 0.5 ......................................................................................................................................................................................................................................................................................................
-              X : ...........................................................................................................................................p:6.0, vr=0.5, 0.5, 0.5 ...................................................................................................................................................................................................................................j:5, 6, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 
-              2 : .................................................................................................................................................................................................................................................................................................................................................................................................................................................
-              ) : ...................................................................................................................p:5.0, vr=0.5, 0.5, 0.5 ......................................................................................................................................................................................................................................................................................................
+                  p: p:1.0 p:2.0 p:3.0 p:4.0 p:5.0 p:6.0 j:0, 1, dx=1.0, 0.0, 0.0 j:1, 2, dx=1.0, 0.0, 0.0 j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0 j:3, 4, dx=1.0, 0.0, 0.0 j:4, 5, dx=1.0, 0.0, 0.0 j:5, 6, dx=1.0, 0.0, 0.0 
+              2 : .........................................................................................................................................................................................................
+              X : p: p:1.0 p:2.0 ........................j:0, 1, dx=1.0, 0.0, 0.0 j:1, 2, dx=1.0, 0.0, 0.0 ................................................................................................................
+              2 : .........................................................................................................................................................................................................
+              r : .........p:2.0 ..........................................................................................................................................................................................
+              3 : .........................................................................................................................................................................................................
+              X : ...............p:3.0 p:4.0 p:5.0 ........................................................j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0 j:3, 4, dx=1.0, 0.0, 0.0 j:4, 5, dx=1.0, 0.0, 0.0 .........................
+              2 : .........................................................................................................................................................................................................
+              ( : ...........................p:5.0 ........................................................................................................................................................................
+              X : .................................p:6.0 .........................................................................................................................................j:5, 6, dx=1.0, 0.0, 0.0 
+              2 : .........................................................................................................................................................................................................
+              ) : ...........................p:5.0 ........................................................................................................................................................................
 Reverse conversion map:
-{ [0-42] -> [1]
-  [43-66] -> [1,3]
-  [67-114] -> [5]
-  [115-138] -> [5,7,10]
-  [139-162] -> [8]
-  [163-248] -> [1]
-  [249-389] -> [5]
-  [390-432] -> [8]
+{ [0-8] -> [1]
+  [9-14] -> [1,3]
+  [15-26] -> [5]
+  [27-32] -> [5,7,10]
+  [33-38] -> [8]
+  [39-88] -> [1]
+  [89-175] -> [5]
+  [176-200] -> [8]
 }
                                                 2X2r3X2(X2)
-  p:vr=0.5, 0.5, 0.5 p:1.0, vr=0.5, 0.5, 0.5  : .X.........
-                     p:2.0, vr=0.5, 0.5, 0.5  : .X.r.......
-p:3.0, vr=0.5, 0.5, 0.5 p:4.0, vr=0.5, 0.5, 0 : .....X.....
-                                          .5  : .....X.....
-                     p:5.0, vr=0.5, 0.5, 0.5  : .....X.(..)
-                     p:6.0, vr=0.5, 0.5, 0.5  : ........X..
-j:0, 1, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5 j: : .X.........
-    1, 2, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : .X.........
-j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0, vr=0.5, : .....X.....
- 0.5, 0.5 j:3, 4, dx=1.0, 0.0, 0.0, vr=0.5, 0 : .....X.....
-.5, 0.5 j:4, 5, dx=1.0, 0.0, 0.0, vr=0.5, 0.5 : .....X.....
-                                       , 0.5  : .....X.....
-  j:5, 6, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : ........X..
+                                    p: p:1.0  : .X.........
+                                       p:2.0  : .X.r.......
+                                 p:3.0 p:4.0  : .....X.....
+                                       p:5.0  : .....X.(..)
+                                       p:6.0  : ........X..
+j:0, 1, dx=1.0, 0.0, 0.0 j:1, 2, dx=1.0, 0.0, : .X.........
+                                         0.0  : .X.........
+j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0 j:3, 4,  : .....X.....
+   dx=1.0, 0.0, 0.0 j:4, 5, dx=1.0, 0.0, 0.0  : .....X.....
+                    j:5, 6, dx=1.0, 0.0, 0.0  : ........X..
 
 Model map for fmultiply genotype:
@@ -102,31 +99,30 @@
                                                 Parts     Joints    Neurons
                                                 012345678901234567890123456789
-                          p:vr=0.5, 0.5, 0.5  : 0.............................
-                     p:1.0, vr=0.5, 0.5, 0.5  : .1............................
-                     p:2.0, vr=0.5, 0.5, 0.5  : ..2...........................
-                     p:3.0, vr=0.5, 0.5, 0.5  : ...3..........................
-                     p:4.0, vr=0.5, 0.5, 0.5  : ....4.........................
-                     p:5.0, vr=0.5, 0.5, 0.5  : .....5........................
-                     p:6.0, vr=0.5, 0.5, 0.5  : ......6.......................
-  j:0, 1, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : ..........0...................
-  j:1, 2, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : ...........1..................
-j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0, vr=0.5, : ............2.................
-                                    0.5, 0.5  : ............2.................
-  j:3, 4, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : .............3................
-  j:4, 5, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : ..............4...............
-  j:5, 6, dx=1.0, 0.0, 0.0, vr=0.5, 0.5, 0.5  : ...............5..............
-{ [0-18] -> [0]
-  [19-42] -> [1]
-  [43-66] -> [2]
-  [67-90] -> [3]
-  [91-114] -> [4]
-  [115-138] -> [5]
-  [139-162] -> [6]
-  [163-205] -> [10]
-  [206-248] -> [11]
-  [249-303] -> [12]
-  [304-346] -> [13]
-  [347-389] -> [14]
-  [390-432] -> [15]
+                                          p:  : 0.............................
+                                       p:1.0  : .1............................
+                                       p:2.0  : ..2...........................
+                                       p:3.0  : ...3..........................
+                                       p:4.0  : ....4.........................
+                                       p:5.0  : .....5........................
+                                       p:6.0  : ......6.......................
+                    j:0, 1, dx=1.0, 0.0, 0.0  : ..........0...................
+                    j:1, 2, dx=1.0, 0.0, 0.0  : ...........1..................
+        j:2, 3, rx=-1.5706, dx=1.0, 0.0, 0.0  : ............2.................
+                    j:3, 4, dx=1.0, 0.0, 0.0  : .............3................
+                    j:4, 5, dx=1.0, 0.0, 0.0  : ..............4...............
+                    j:5, 6, dx=1.0, 0.0, 0.0  : ...............5..............
+{ [0-2] -> [0]
+  [3-8] -> [1]
+  [9-14] -> [2]
+  [15-20] -> [3]
+  [21-26] -> [4]
+  [27-32] -> [5]
+  [33-38] -> [6]
+  [39-63] -> [10]
+  [64-88] -> [11]
+  [89-125] -> [12]
+  [126-150] -> [13]
+  [151-175] -> [14]
+  [176-200] -> [15]
 }
 